include "Zeropage.inc"
include "Vram.inc"
; include "Chars.inc"

Char_Space equ $9B

pDestination equ ZW0
pSource equ ZW1


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        lda #low Vram | sta <pDestination
        lda #high Vram | sta <pDestination+1
        ldx #VramHeight+2
        do
            lda #Char_Space
            ldy #0
            do
                sta (<pDestination),y
                iny
                cpy #VramWidth
            while ne | wend

            lda <pDestination | clc | adc #low VramWidth | sta <pDestination
            lda <pDestination+1 | adc #high VramWidth | sta <pDestination+1
            dex
        while ne | wend
    pla
rts


; ptr<byte> VramPtr(byte x, byte y);
dseg
VramPtr_@Param0: public	VramPtr_@Param0
VramPtr_.x_:	defs 1
VramPtr_@Param1: public	VramPtr_@Param1
VramPtr_.y_:	defs 1
cseg
VramPtr_: public	VramPtr_
	pha
        lda	VramPtr_.y_
        asl a | asl a | asl a  ;*8
        sta <ZW0 | lda #0 | sta <ZW0+1
        asl <ZW0 | rol <ZW0+1 ;16
        asl <ZW0 | rol <ZW0+1 ;32
        lda VramPtr_.x_ | clc | adc <ZW0 | sta <ZW0
        lda <ZW0+1 | adc #0 | sta <ZW0+1
        lda <ZW0 | clc|adc #low Vram | tay
        lda <ZW0+1 | adc #high Vram | tax
	pla
rts


; ptr<byte> PrintC(ptr<byte> pVram, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_.pVram_:	defs 2
PrintC_@Param1: public PrintC_@Param1
PrintC_.c_:	defs 1
cseg
CharTable:
    defb '-0123456789ABCEGHIMNOPRSTUV'
PrintC_: public PrintC_
    pha
        lda PrintC_@Param1
        ldx #0
        do
            cmp CharTable,x
            beq PrintC_exit
            inx
            cpx #27
        while ne | wend
        ldx #Char_Space
        PrintC_exit:        
        lda PrintC_@Param0 | sta <pDestination
        lda PrintC_@Param0+1 | sta <pDestination+1
        txa | ora #$80
        ldy #0
        sta (<pDestination),y

        lda <pDestination | clc|adc #1 | tay
        lda <pDestination+1 | adc #0 | tax
    pla
rts
